<?
//$Id: basic_services.php,v 1.4 2010-12-16 13:30:51 calicant Exp $

require "../../adm/lib/setup.php";

$GOOD_REQUEST_TABLES = array(
    'node',
    'papernode',
    'tags',
    'objlibrary',
    'core_image',
    'core_attach'
);

if (trim($_POST['action'])) {
    if (function_exists($_POST['action'])) {
        $ret = $_POST['action']($connh);
        echo $ret;
    }
}

function get_field_value($connh) {
    global $GOOD_REQUEST_TABLES;

    if (trim($_POST['table']) && in_array($_POST['table'], $GOOD_REQUEST_TABLES))
        $table = "`".$_POST['table']."`";
    else
        return '';

    if (trim($_POST['match'])) {
        $match = "`".$_POST['match']."` LIKE '".$_POST['typedstring']."%'";
    }
    else
        return '';

    if (count($_POST['where'])) {
        foreach ($_POST['where'] as $key => $val) {
            if ($_POST['where'][$key])
                $where .= " and `".$key."`='".$_POST['where'][$key]."'";
        }
    }

    $rs = $connh->Execute("SELECT * FROM ".$table." WHERE ".$match." ".$where." ORDER BY ".$_POST['match']);
    if ($rs->RecordCount()) {

        $ret = "[";
        while (!$rs->EOF) {
            $ret .= "{'id': '".$rs->fields['id']."', 'sezione': '".$rs->fields[$_POST['match']]."'}, ";
            $rs->MoveNext();
        }
        $ret .= "]";
    
        return $ret;
    }
}

function get_tree($connh) {
    $usertable = $_SESSION['PRISCILLA_SESSION']->getvalue('usertable');
    $rsconf = select("SELECT * FROM user_map WHERE id='".$usertable['id']."'", $connh);

    if (defined("PRISCILLA_SEO_PAGE") AND PRISCILLA_SEO_PAGE == true)
        $have_seo = true;
    else
        $have_seo = false;

    // file di lingua per funzioni albero
    include PRISCILLA_LOCAL_PATH."tools/lang/".$usertable['lingua']."/dialog.diz";

    if (!$_POST['id'])
        $_POST['id'] = 1;

    if ($_POST['mode'] == 'user' && $_POST['id'] != 1)
        $where = "and id_user='".$_COOKIE['login']."'";
    else
        $where = "";

    $ret = "\n<ol id=\"tree-".$_POST['id']."\" class=\"sortable-list\">";
    $paper_action_path = PRISCILLA_SERVER_PATH."modules/paper/lib/actions.php";
    $rs = select("SELECT * FROM node WHERE id_parent='".$_POST['id']."' $where ORDER BY rilevanza DESC", $connh);
    while (!$rs->EOF) {
        if ($rs->fields['id_user'] == $usertable['username']) {
            $linkclass = "class=\"tree_mylink\"";
            $liclass = "class=\"tree_mygen\"";
        }
        else {
            $linkclass = "class=\"tree_link\"";
            $liclass = "class=\"tree_gen\"";
        }

        $commands = '';
        $info = '';
		if ($rsconf->RecordCount() > 0)
        foreach ($rsconf->fields as $k => $v) {
            switch ($k) {
                // azioni sulle pagine (per redattori proprietari)
                case 'map_cnt':
                    if ($v == 'si' && $rs->fields['id_user'] == $usertable['username'])
                        $commands .= "&nbsp;<a href=\"".$paper_action_path."?action=edit_page&id=".$rs->fields['id']."\" $linkclass>[".dialog_tree_cnt."]</a>";
                break;
                case 'map_pub':
                    if ($v == 'si' && $rs->fields['id_user'] == $usertable['username']) {
                        if ($rs->fields['pubblicazione'] == 'privata' || $rs->fields['pubblicazione'] == 'redazionepriv')
                            $commands .= "&nbsp;<a href=\"".$paper_action_path."?action=set_pub&map_set_id=".$rs->fields['id']."&pub=pubblica&lastaction=show_tree\" $linkclass title=\"rendi la pagina pubblica\">[PUB]</a>";
                        else
                            $commands .= "&nbsp;<a href=\"".$paper_action_path."?action=set_pub&map_set_id=".$rs->fields['id']."&pub=privata&lastaction=show_tree\" $linkclass title=\"rendi la pagina non pubblica\">[PRV]</a>";
                    }
                break;
                case 'map_tpl':
                    if ($v == 'si' && $rs->fields['id_user'] == $usertable['username'])
                        $commands .= "&nbsp;<a href=\"".PRISCILLA_SERVER_PATH."tools.php?action=edit_template&name=".$rs->fields['template']."&id=".$rs->fields['id']."\" $linkclass>[TPL]</a>";
                break;
                case 'map_css':
                    if ($v == 'si' && $rs->fields['id_user'] == $usertable['username'])
                        $commands .= "&nbsp;<a href=\"".PRISCILLA_SERVER_PATH."tools.php?action=edit_stile&name=".$rs->fields['stile']."&id=".$rs->fields['id']."\" $linkclass>[CSS]</a>";
                break;
                // info sulle pagine
                case 'map_lastmod':
                    $info .= "&nbsp;<strong>".dialog_tree_upd."</strong>".$rs->fields['lastmod'];
                break;
                case 'map_visite':
                    $info .= "&nbsp;<strong>".dialog_tree_hit."</strong>".$rs->fields['visite'];
                break;
            }
        }

        $ret .= "\n<li id=\"leaf".$rs->fields['id']."\" $liclass>";

        $totchildern = 0;
        getChildrenBranchNumber($connh, $rs->fields['id'], $totchildern);

        $rsc = select("SELECT id FROM node WHERE id_parent='".$rs->fields['id']."'", $connh);
        if ($rsc->RecordCount() > 0)
            $ret .= "<a href=\"javascript:;\" id=\"expander".$rs->fields['id']."\" onclick=\"expand_leaf('".$rs->fields['id']."')\" $linkclass title=\"$totchildern children\">[+]</a> ";
        else
            $ret .= "<a id=\"expander".$rs->fields['id']."\" $linkclass>[&nbsp;]</a> ";
        
        if ($have_seo)
            $index_page = maketitle($rs->fields('id'),  seotitle($rs->fields('sezione')), false);
        else
            $index_page = "index.php?id=".$rs->fields['id'];

        $ret .= "<a href=\"".PRISCILLA_SERVER_PATH . $index_page ."\" $linkclass>". htmlentities($rs->fields['sezione'], ENT_COMPAT, PRISCILLA_CHARSET) ."</a> ".$commands." ".$info."<div id=\"expand".$rs->fields['id']."\"></div></li>";
        $rs->MoveNext();
    }
    
    $ret .= "\n</ol>";

    return $ret;
}

function get_json_tree($connh) {

    if (!$_POST['id'])
        $_POST['id'] = 1;

    $ret .= "[";

    $rs = select("SELECT * FROM node WHERE id_parent='".$_POST['id']."' ORDER BY rilevanza DESC", $connh);
    if (!$rs->RecordCount())
        return $ret."]";

    while (!$rs->EOF) {

        // necessario per sapere a priori se il nodo corrente ha figli
        $rsc = select("SELECT * FROM node WHERE id_parent='".$rs->fields['id']."'", $connh);
        if (!$rsc->RecordCount())
            $hasC = ",\n\thasChildren: false";
        else
            $hasC = ",\n\tstate: 'closed',\n\thasChildren: true";

        $ret .= "\n{\n\tattributes: {id: '".$rs->fields['id']."', class: 'tree_link', title: 'Il nodo ha ".$rsc->RecordCount()." figli'}$hasC,\n\tdata: '".$rs->fields['sezione']."'},";

        $rs->MoveNext();
    }
    
    $ret .= "\n]";

    return $ret;
}


?>
