<?
// $Id: module_body.inc.php,v 1.2 2010/07/06 12:15:57 riccardo Exp $

require_once "lib/test_auth.php";

require_once PRISCILLA_LOCAL_PATH."modules/priscilla_datatonic/lang/$lang/priscilla_datatonic.diz";
require_once "../packages/crypt/Rc4.php";

// parametri riconosciuti, default, commenti, tipo
$a_valid_param = array(
    "PAPER_HOMENEWS_CONTENT_TABLE" => array ("content_base", "tabella di contenuti da utlizzare", "text"),
    "PAPER_HOMENEWS_DATEIN_FIELD" => array ("", "campo data pubblicazione", "text"),
    "PAPER_HOMENEWS_DATEOUT_FIELD" => array ("", "campo data ritiro", "text"),
    "PAPER_HOMENEWS_LEVEL_FIELD" => array ("", "campo livello", "text"),
    "PAPER_HOMENEWS_DEFAULT_N" => array("", "numero di default di news da estrarre", "text"),
    "PAPER_HOMENEWS_DEFAULT_ORDER_FIELD" => array("rilevanza", "campo default di ordinamento", "text"),
    "PAPER_HOMENEWS_DEFAULT_ORDER_DIR" => array("asc", "verso default di ordinamento", "text"),
    "PAPER_BIGPANEL_ACTIVE" => array(0, "attiva il pannello redazionale paper", "boolean"),
    "PAPER_BIGPANEL_USER_0" => array(0, "attiva il pannello redazionale paper per i redattori di livello 0", "boolean"),
    "PAPER_BIGPANEL_USER_1" => array(0, "attiva il pannello redazionale paper per i redattori di livello 1", "boolean"),
    "PAPER_BIGPANEL_USER_2" => array(0, "attiva il pannello redazionale paper per i redattori di livello 2", "boolean"),
    "PAPER_BIGPANEL_USER_3" => array(0, "attiva il pannello redazionale paper per i redattori di livello 3", "boolean")
);

$a_boolean = array (
    "0" => "false",
    "1" => "true"
);


$target_file = $priscilla_local_path."modules/paper/inc/config.inc.php";

function save_vars ($target_file, $vars) {
global $a_valid_param, $priscilla_local_path;

    $fp = fopen($target_file, "w+");
    if (!$fp)
        die("Fatal Error: could not write setup file: '$target_file'");
    fputs($fp, "<?\n\n");

    foreach ($vars as $k=>$v) {
        fputs($fp, "// " . $a_valid_param[$k][1] . "\n");

        // password viene crittata
        if (trim($k) == "PRISCILLA_DATATONIC_ACCESS_PASSWORD") {
            $cpwd = $v[0];
            $ckey = $priscilla_local_path;

            if ($ckey{strlen($ckey) - 1} != "/")
                $ckey .= "/";
            $rc4 = new Crypt_RC4($ckey);
            $rc4->crypt($cpwd);
            $v[0] = base64_encode($cpwd);
            unset($rc4);
        }

        fputs($fp, "define (\"" . $k . "\", \"" . $v[0] . "\");\n\n");

    }
    fputs ($fp, "\n?>\n");
    fclose($fp);
} // save_vars


// se si arriva da un post si salvano le preferenze
if  (isset($_POST['bSubmit']) && isset($_POST['tosave']) && is_array($_POST['tosave']) && count($_POST['tosave']))
    save_vars($target_file, $tosave);


// se il file non esiste si va di default
if (!file_exists($target_file))
    save_vars($target_file, $a_valid_param);

// pannello impostazione parametri del modulo di comunicazione con datatonic
$datatonic_config = file_get_contents($target_file);


$regexp = "/^define \(" . "[\"|']" . "(.*)" . "[\"|']" . ", " . "(.*)" . "\);/m";
if ($regexp_res = preg_match_all ($regexp, $datatonic_config, $match, PREG_SET_ORDER)) {


    $ngood = 0;

    echo     
        "<form name=\"fperefences\" method=\"post\">\n" .
        "<table width=\"80%\" class=\"table_border\" align=\"center\" cellpadding=\"2\" cellspacing=\"1\" border=\"0\">\n" .
        "<tr><th class=\"table_tit\" colspan=\"2\">PAPER</th>\n";

    foreach ($match as $cdata) {


        $k = $cdata[1];
        $v = str_replace("\"", "", $cdata[2]);
        

        if (!isset($a_valid_param[$k]))
            continue;

        $ngood++;
        $ctype = $a_valid_param[$k][2];

        if ($ctype == "boolean") {
            $valore_param = "<select name=\"tosave[$k][]\" size=\"1\" class=\"insert_area\">\n";

            foreach ($a_boolean as $bk=>$bv) {
                $is_selected = $v ? "selected" : "";
                $valore_param .= "<option $is_selected value=\"$bk\">$bv</option>\n";
            }

            $valore_param .= "</select>\n";
        }
        else if ($ctype == "text" || $ctype == "password") {


            // password viene decrittata
            if (trim($k) == "PRISCILLA_DATATONIC_ACCESS_PASSWORD") {
                $cpwd = base64_decode($v);
                $ckey = $priscilla_local_path;
                if ($ckey{strlen($ckey) - 1} != "/")
                    $ckey .= "/";
                $rc4 = new Crypt_RC4($ckey);
                $rc4->decrypt($cpwd);
                $v = $cpwd;
                unset($rc4);
            }

            $valore_param = "<input type=\"" . $ctype . "\" name=\"tosave[" . $k . "][]\" value=\"" . $v . "\" size=\"50\"class=\"insert_area\">";
        }
        else die ("Unknown type '$ctype' for config param '" . $k . "'");

        echo
            "<tr>\n<td width=\"50%\" align=\"center\" class=\"table_sez\">" . $k . "</td>\n" .
            "<td width=\"50%\" align=\"center\" class=\"insert_voice\">" . $valore_param . "</td>\n</tr>";

    } // foreach

    if ($ngood)
        echo "<tr>\n<td colspan=\"2\" align=\"center\" class=\"button_out\"><input type=\"submit\" name=\"bSubmit\" value=\"" . PRISCILLA_DATATONIC_PREFERENCES_SAVE . "\" class=\"button_in awesome\"></tr>";

    echo "</table>\n</form>\n";
}

?>

