<?
// $Id: cal.php,v 1.1 2010/09/27 06:59:11 calicant Exp $

require "../../../adm/lib/setup.php";
require "../inc/config.inc.php";

$a_params = array("todaysid", "eventsid");

foreach ($a_params as $p)
    if (!isset($_GET[$p]) || !is_numeric($_GET[$p]) || $_GET[$p] == 0)
        die("ECAL: parametri di ingresso non validi");


$debug = 0;

$a_m = array(
    "",
    "Gennaio",
    "Febbraio",
    "Marzo",
    "Aprile",
    "Maggio",
    "Giugno",
    "Luglio",
    "Agosto",
    "Settembre",
    "Ottobre",
    "Novembre",
    "Dicembre"
);


$t = time();

$realyear = date("Y", $t);
$realmonth = date("n", $t);
$realday = date("d", $t);

$todaytime = mktime(0, 0, 0, $realmonth, $realday, $realyear);

if (isset($_GET["year"]))
    $year = $_GET["year"];
else
    $year = $realyear;

if (isset($_GET["month"]))
    $month = $_GET["month"];
else
    $month = $realmonth;

if (isset($_GET["day"]))
    $day = $_GET["day"];
else
    $day = $realday;


$daysInMonth = date("t", mktime(0, 0, 0, $month, 1, $year));
$firstDay = date("w", mktime(0, 0, 0, $month, 1, $year));
$tempDays = $firstDay + $daysInMonth - 1;
$weeksInMonth = ceil($tempDays / 7);
$counter = 1;

// echo "wim $weeksInMonth | fd $firstDay <br />\n";


if ($firstDay == 0) {
	$week[0][1] = "";
	$week[0][2] = "";
	$week[0][3] = "";
	$week[0][4] = "";
	$week[0][5] = "";
	$week[0][6] = "";
	$week[0][7] = 1;
}

    // create a 2-d array
for($j=1; $j <= $weeksInMonth;$j++) {
    for($i=1; $i<=7;$i++) {
        $counter++;
        $week[$j][$i] = $counter; 

        // offset the days
        $week[$j][$i] -= $firstDay;
        if (($week[$j][$i] < 1) || ($week[$j][$i] > $daysInMonth))
            $week[$j][$i] = "";
    }
}

$pmonth = $month - 1;
$pyear = $year;

if ($pmonth == 0) {
    $pmonth = 12;
    $pyear--;
}

$nmonth = $month + 1;
$nyear = $year;
if ($nmonth == 13) {
    $nmonth = 1;
    $nyear++;
}


$pLink = "?year=$pyear&month=$pmonth&day=1&todaysid=" . $_GET["todaysid"] . "&eventsid=" . $_GET["eventsid"];
$nLink = "?year=$nyear&month=$nmonth&day=1&todaysid=" . $_GET["todaysid"] . "&eventsid=" . $_GET["eventsid"];

$a_events = array();

$pmonth =
	"<a class=\"calLink\" href=\"$pLink\">" .
	"<img alt=\"\" width=\"16\" height=\"16\" src=\"../pix/arrow_2_left_round.png\" />" .
	"</a>";


$testaMonth = "<span class=\"titleCal\">" . $a_m[$month] . " " . $year . "</span>";

$nmonth =
	"<a class=\"calLink\" href=\"$nLink\">" .
	"<img alt=\"\" width=\"16\" height=\"16\" src=\"../pix/arrow_2_right_round.png\" />" .
	"</a>";


$s_navigator =
        "<th class=\"calNav\">$pmonth</th><th class=\"calTesta\" colspan=\"5\">$testaMonth</th><th class=\"calNav\">$nmonth</th>\n";


$filter_month = sprintf("%02d", $month);
$filter_lastday = sprintf("%02d", $daysInMonth);

$date_start = $year . "-" . $filter_month . "-01";
$date_end = $year . "-" . $filter_month . "-" . $filter_lastday;



$dbquery = "SELECT * FROM `ecal_calendar` WHERE ((`data` >= '$date_start' AND `data` <= '$date_end') OR (`data_end` IS NOT NULL AND (`data` <= '$date_start' AND `data_end` >= '$date_start'))) AND `pub` = 'si'";


if ($debug)
    echo $dbquery . "<br />";

$rs = $connh->Execute($dbquery);
if (!$rs && $debug)
    echo $connh->ErrorMsg() . "<br />";

if ($rs && $rs->RecordCount()) {

    while (!$rs->EOF) {
        $row = $rs->fields;

        $id = $rs->fields('id');
        $a_day = explode("-", $rs->fields('data'));
      	$s_day = (int)($a_day[2]);

	$current_day_time = mktime(0, 0, 0, (int)($a_day[1]), $s_day, (int)($a_day[0]));


	// se abbiamo un intervallo coloriamo tutte le date comprese

	if ($rs->fields('data_end') != "0000-00-00" && trim($rs->fields('data_end') != "") && $rs->fields('data_end') != $rs->fields('data')) {

		$a_day_start = explode("-", $rs->fields('data'));
		$a_day_end = explode("-", $rs->fields('data_end'));

		$s_d = $a_day_start[2];
		$s_m = $a_day_start[1];
		$s_y = $a_day_start[0];

		$e_d = $a_day_end[2];
		$e_m = $a_day_end[1];
		$e_y = $a_day_end[0];

/*
		if ($s_m != $a_day[1])
			$s_m = $a_day[1];
		if ($s_y != $a_day[0])
			$s_y = $a_day[2];
*/
		if ($debug) {
			echo "id = $id, data start = " . $rs->fields('data') . ", data end = $e_d $e_m $e_y ovvero = " . $rs->fields('data_end') . "<br />";
		}

		$dstime = mktime(0, 0, 0, $s_m, $s_d, $s_y);
		$detime = mktime(0, 0, 0, $e_m, $e_d, $e_y);

		for ($j = 1; $j <= $daysInMonth; $j++) {

			if ($debug)
				echo "testing day $j (from $s_day to day $daysInMonth of month $month<br />\n";

			$cutime = mktime(0, 0, 0, $month, $j, $year);
			if ($cutime >= $dstime && $cutime <= $detime && $cutime >= $todaytime) {

				if ($debug)
					echo "**** $cutime in ($dstime, $detime)" . "<br />";

				$a_events[$j][$id] = 1;
			}				

		}

	}


	if ($current_day_time >= $todaytime)
	        $a_events[$s_day][$id] = 1;
        $rs->MoveNext();
    } // while
}

if ($debug) {
    echo "<pre>";
    print_r($a_events);
    echo "</pre>";
}

?>
<html>
<head>
<link rel="stylesheet" media="all" type="text/css" href="../../../style/cal.css" />
</head>
<body>
<table id="customCalendar">
    <tr>
    <? echo $s_navigator; ?>
    </tr>
    <tr>
        <th>Lun</th>
        <th>Mar</th>
        <th>Mer</th>
        <th>Gio</th>
        <th>Ven</th>
        <th>Sab</th>
        <th>Dom</th>
    </tr>

<?php
foreach ($week as $key => $val) { 
    echo "<tr>";
    for ($i=1;$i<=7;$i++) {
        $v = $week[$key][$i];
        if (trim($v) == "")
            $v = "&nbsp;";

	$currClass = "";

        if ($i == 7)
            $currClass = "adomday";
        else
            $currClass = "aday";

        if ($v == $realday  && $month == $realmonth && $year = $realyear) {
            $currClass = "today";
	    $topage = "../../../index.php?id=" . $_GET["todaysid"];
    	}
	else
	    $topage = "../../../index.php?id=" . $_GET["eventsid"];

        $nv = (int)$v;

        if ($nv && isset($a_events[$nv])) {
	    if ($currClass == "today")
	    	$currClass = "haveEvent today";
            else
	    	$currClass = "haveEvent";
            $nevents = count($a_events[$nv]);
            $sitepage = $topage . "&cal_i=" . $year . "-" . $filter_month . "-" . $nv . "&cal_t=day";
            $s_text = $nevents . " event";
            $s_text .= ($nevents > 1) ? "i" : "o"; 
            $v = "<a title=\"$s_text\" target=\"_top\" class=\"eventLink\" href=\"$sitepage\">$v</a>"; 
        }

        echo "<td class=\"$currClass\">" . $v . "</td>\n";
    }
    echo "</tr>\n";
}
?>
</table>
</body>
</html>
