<?php

// $Id: module_body.inc.php,v 1.1.1.1 2008/11/06 10:53:10 antonio Exp $
require_once "lib/test_auth.php";


require ($module_dir . "/lang/$lang/thebanner.diz");
require_once ($module_dir . "/lib/thebanner_class.php");


$thebanner = new TheBanner ($connh, $_COOKIE['login']);

if ($thebanner->statusError)
    die("Fatal Error: TheBanner constructor failed (error code = " . $thebanner->statusError .  ")");

//$thebanner->setDebug(1);


if (isset($_POST['bannerList']))
    $bannerList = $_POST['bannerList'];
// si settano alcuni default
else {
    $bannerList['sizetype'] = 1;
    $bannerList['visibility'] = 'public';
    $bannerList['position'] = 0;
    $bannerList['showlimit'] = 0;
    $bannerList['owner'] = 0;
}


//echo "<br />\n";

    // aggiunta di banner a un gruppo (eventuale creazione del gruppo)
    // oppure rimozione di banner dalla lista generale
    if (isset($_POST['addbanners']) && $_POST['addbanners'] == 'ok' && isset($_POST['bannerList']) && isset($_POST['bannerAdd']))
	$thebanner->handleAdding($_POST['bannerList'], $_POST['bannerAdd']);

    // post di un nuovo banner
    if (isset($_POST['incoming']) && $_POST['incoming'] == 'ok' && isset($_POST['bannerInfo']))
	$thebanner->handleUpload($_POST['bannerInfo'], $bannerList);

    // modifica delle propriet&agrave; di un banner
    if (isset($_POST['bannermodify']) && is_numeric($_POST['bannermodify']) && $_POST['bannermodify'] && !isset($_POST['bTopanel']))
	$thebanner->handleBannerModify($_POST['bannermodify'], $_POST['bannerModify'], $bannerList);

    // modifica delle dimensioni dei banner
    if (isset($_POST['sizemodify']) && $_POST['sizemodify'] == 'ok' && !isset($_POST['bTopanel']))
	$thebanner->handleSizeModify($bannerList, $_POST['sizeNew'], $_POST['sizeRemove']);

    // cancellazione di banner da un gruppo
    if (isset($_POST['groupinfo']) && isset($_POST['bBannerRemove']) &&
	isset($_POST['groupID']) && is_numeric($_POST['groupID']))
	$thebanner->handleRemoving($_POST['groupID'], $_POST['bannerRemove']);    

    // modifica della visibilita' e/o cancellazione di un gruppo
    if (isset($_POST['grouplist']) && $_POST['grouplist'] == 'ok')
	$thebanner->handleGroupEditing ($_POST['bGroupVisibility'], $_POST['bGroupDelete'], $_POST['bGroupShow'], $bannerList);

    // per continuare a mostrare il gruppo dopo una rimozione
    if ((isset($_POST['bannerRemove']) && isset($_POST['bGroupShow'])) || isset($_POST['bBannerRemove']))
 	$thebanner->handleGroupEditing ($_POST['bGroupVisibility'], $_POST['bGroupDelete'], $_POST['bGroupShow'], $bannerList);

    // eventuali errori vengono stampati (quasi sempre in testa ;)
    $thebanner->outError();

    // se si mostrano o cancellano banner di un gruppo, si evitano di stampare gli alti form
    // vedi infra
    // con l'eccezione del caso in cui si voglia ritornare al main panel ('bTopanel')
    if ((isset($_POST['bGroupShow']) || isset($_POST['bannerRemove']) ||
	isset($_POST['bannermodify']) || isset($_POST['sizemodify'])) && !isset($_POST['bTopanel']))
	;
    else {
	$thebanner->showBannerList($bannerList, $_POST['resetpositionstatus']);
//	echo "<br />\n";
	$thebanner->uploadBanner($bannerList);
//	echo "<br />\n";
	$thebanner->showGroupList($bannerList);
    }

    // il fake form per gestire le modifiche ai banner
    $thebanner->showFormBannerModify($bannerList);

    // il fake form per gestire le modifiche alla lista size
    $thebanner->showFormSizeModify($bannerList);

echo "<br />\n";

?>

